searchNodes=[{"doc":"Hashes and verifies passwords. Nearly all password formats are PHC , except for Bcrypt which uses its own format. examples: // argon2id &quot;$argon2id$v=19$m=19456,t=2,p=1$gxbjqzYr4kRe9XSK9k4geA$PIJQSj+ooUKQp86FUZf7xkbmNqpHEuL9lnQlHCGPCHg&quot; // bcrypt &quot;$2a$12$5udTI/WUkIdt4n7Rt5x0cOcLjoc.Ax1sSvr3qrBkTTQu1y6sbDVLK&quot; This because Bcrypt in other libraries in other languages also use this format (checked: python, ruby, rust, elixir) Hashing iex&gt; # just use the default algorithm set iex&gt; { :ok , &quot;$argon2id&quot; &lt;&gt; _ } = Password . hash ( &quot;qwerty&quot; ) iex&gt; # pick the algorithm you want iex&gt; { :ok , &quot;$scrypt&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :scrypt ) iex&gt; # bcrypt version 2b iex&gt; { :ok , &quot;$2b&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :&quot;2b&quot; ) iex&gt; { :ok , &quot;$pbkdf2&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :pbkdf2 ) iex&gt; # pick the algorithm you want with setting custom options (this is another option OWASP suggests) iex&gt; { :ok , &quot;$argon2id$v=19$m=7168,t=5,p=1$&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :argon2id , %{ &quot;m&quot; =&gt; 7168 , &quot;t&quot; =&gt; 5 , &quot;p&quot; =&gt; 1 } ) Verifying iex&gt; hash = &quot;$argon2id$v=19$m=19456,t=2,p=1$gxbjqzYr4kRe9XSK9k4geA$PIJQSj+ooUKQp86FUZf7xkbmNqpHEuL9lnQlHCGPCHg&quot; iex&gt; Password . verify ( &quot;testing1234&quot; , hash ) :ok iex&gt; # set a list of allowed algorithms that are used iex&gt; Password . verify_with ( &quot;testing1234&quot; , hash , [ :argon2id ] ) :ok iex&gt; Password . verify_with ( &quot;testing1234&quot; , hash , [ :scrypt , :bcrypt ] ) { :error , &quot;algorithm not in allowed list&quot; }","ref":"Password.html","title":"Password","type":"module"},{"doc":"Hashes password and returns the hashed password in PHC form iex&gt; { :ok , &quot;$argon2id&quot; &lt;&gt; _ } = Password . hash ( &quot;qwerty&quot; )","ref":"Password.html#hash/1","title":"Password.hash/1","type":"function"},{"doc":"Same as Password.hash_with/3 but with the default settings for each algorithm","ref":"Password.html#hash_with/2","title":"Password.hash_with/2","type":"function"},{"doc":"Hashes password and returns the hashed password in PHC form. Unless it is bcrypt which returns its own format. iex&gt; { :ok , &quot;$argon2id&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :argon2id ) iex&gt; { :ok , &quot;$argon2id&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :argon2 ) # :argon2 is an alias for :argon2id iex&gt; { :ok , &quot;$scrypt&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :scrypt ) iex&gt; { :ok , &quot;$2b$12$&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :&quot;2b&quot; ) iex&gt; { :ok , &quot;$2b$12$&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :bcrypt ) # :bcrypt is an alias for :&quot;2b&quot; iex&gt; { :ok , &quot;$pbkdf2&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :pbkdf2 ) Set custom options, the arguments are the same as set in the PHC format iex&gt; { :ok , &quot;$argon2id$v=19$m=7168,t=5,p=1$&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :argon2id , %{ &quot;m&quot; =&gt; 7168 , &quot;t&quot; =&gt; 5 , &quot;p&quot; =&gt; 1 } ) iex&gt; { :ok , &quot;$scrypt$ln=5,r=2,p=1$&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :scrypt , %{ &quot;ln&quot; =&gt; 5 , &quot;r&quot; =&gt; 2 , &quot;p&quot; =&gt; 1 } ) iex&gt; { :ok , &quot;$2b$08$&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :&quot;2b&quot; , %{ &quot;cost&quot; =&gt; 8 } ) iex&gt; { :ok , &quot;$pbkdf2-sha256$i=8000,l=32$&quot; &lt;&gt; _ } = Password . hash_with ( &quot;qwerty&quot; , :&quot;pbkdf2-sha256&quot; , %{ &quot;i&quot; =&gt; 8000 } )","ref":"Password.html#hash_with/3","title":"Password.hash_with/3","type":"function"},{"doc":"Returns a list of known algorithms ordered by relevance iex&gt; Password . known_algorithms ( ) [ :argon2id , :argon2i , :argon2d , :scrypt , :&quot;2b&quot; , :&quot;2y&quot; , :&quot;2x&quot; , :&quot;2a&quot; , :&quot;pbkdf2-sha512&quot; , :&quot;pbkdf2-sha256&quot; , :pbkdf2 ]","ref":"Password.html#known_algorithms/0","title":"Password.known_algorithms/0","type":"function"},{"doc":"Returns a list of recommended algorithms iex&gt; Password . recommended_algorithms ( ) [ :argon2id , :scrypt ]","ref":"Password.html#recommended_algorithms/0","title":"Password.recommended_algorithms/0","type":"function"},{"doc":"Verify password against the given hashed password iex&gt; { :ok , hash } = Password . hash ( &quot;qwerty&quot; ) iex&gt; Password . verify ( &quot;qwerty&quot; , hash ) :ok iex&gt; Password . verify ( &quot;qwerty!&quot; , hash ) { :error , &quot;invalid password&quot; }","ref":"Password.html#verify/2","title":"Password.verify/2","type":"function"},{"doc":"Verify password against the given hashed password. The last argument is a list of allowed password algorithms, for if you still store some passwords in a old algorithm which is not allowed anymore. iex&gt; { :ok , hash } = Password . hash_with ( &quot;qwerty&quot; , :&quot;2a&quot; ) iex&gt; Password . verify_with ( &quot;qwerty&quot; , hash , [ :argon2id , :scrypt ] ) { :error , &quot;algorithm not in allowed list&quot; } iex&gt; Password . verify_with ( &quot;qwerty&quot; , hash , [ :&quot;2b&quot; , :&quot;2a&quot; ] ) :ok","ref":"Password.html#verify_with/3","title":"Password.verify_with/3","type":"function"},{"doc":"","ref":"Password.html#t:algorithm/0","title":"Password.algorithm/0","type":"type"},{"doc":"","ref":"Password.html#t:error/0","title":"Password.error/0","type":"type"},{"doc":"","ref":"Password.html#t:hash_settings/0","title":"Password.hash_settings/0","type":"type"},{"doc":"","ref":"Password.html#t:hashed_password/0","title":"Password.hashed_password/0","type":"type"},{"doc":"","ref":"Password.html#t:plain_text/0","title":"Password.plain_text/0","type":"type"},{"doc":"Module for linking Elixir to the Rust library","ref":"Password.Native.html","title":"Password.Native","type":"module"},{"doc":"","ref":"Password.Native.html#hash/1","title":"Password.Native.hash/1","type":"function"},{"doc":"","ref":"Password.Native.html#hash_with/3","title":"Password.Native.hash_with/3","type":"function"},{"doc":"","ref":"Password.Native.html#known_algorithms/0","title":"Password.Native.known_algorithms/0","type":"function"},{"doc":"","ref":"Password.Native.html#recommended_algorithms/0","title":"Password.Native.recommended_algorithms/0","type":"function"},{"doc":"","ref":"Password.Native.html#verify/2","title":"Password.Native.verify/2","type":"function"},{"doc":"","ref":"Password.Native.html#verify_with/3","title":"Password.Native.verify_with/3","type":"function"}]